/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  superstition
* score: 45.0
* date:  2017-11-24 10:28:00.355847
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
const int MAXN = (82);
const int mod = (int)1e9 + 7;

int n, m, d, k;
int G[MAXN][MAXN];
int maxt;

void read()
{
    cin >> n >> m >> d >> k;
    for(int i = 0; i < m; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;

        G[u][v] = t;
        G[v][u] = t;
    }
}

int dp[MAXN][100042];

int rec(int u, int T)
{
    if(T > k) return 0;

    int &memo = dp[u][T];
    if(memo != -1)
        return memo;

    memo = (T % d == 0);
    for(int v = 1; v <= n; v++)
        if(G[u][v] != 0)
            memo = (memo + rec(v, T + G[u][v])) % mod;

    return memo;
}

typedef vector<vector<int> > mat;

int psz;
int new_node() { return ++psz; }


mat mult(mat a, mat b)
{
    mat ret;
    ret.assign(psz + 1, vector<int>(psz + 1, 0));

    for(int i = 1; i <= psz; i++)
        for(int j = 1; j <= psz; j++)
            for(int k = 1; k <= psz; k++)
                ret[i][j] = (ret[i][j] + (a[i][k] * 1ll * b[k][j]) % mod) % mod;

    return ret;
}

void solve()
{
    if(k <= 100000)
    {
        memset(dp, -1, sizeof(dp));

        int answer = mod - n;
        for(int i = 1; i <= n; i++)
            answer = (answer + rec(i, 0)) % mod;

        cout << answer << endl;
        return;
    }

    psz = n;

    int cnt = n;
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            if(G[i][j] > 0)
                cnt += G[i][j] - 1;

    mat ret;
    ret.assign(cnt + 1, vector<int>(cnt + 1, 0));

    mat base;
    base.assign(cnt + 1, vector<int>(cnt + 1, 0));

    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            if(G[i][j] > 0)
            {
                int last = i;
                for(int p = 0; p < G[i][j] - 1; p++)
                {
                    int curr = new_node();
                    base[last][curr] = 1;
                    last = curr;
                }

                base[last][j] = 1;
            }

    ret = base;
    k--;
    while(k)
    {
        if(k % 2 == 1) ret = mult(ret, base);
        base = mult(base, base);
        k /= 2;
    }

    int answer = 0;
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            answer = (answer + ret[i][j]) % mod;

    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
