/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  superstition
* score: 5.0
* date:  2017-11-24 11:45:43.652268
*/
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <tuple>
#include <map>
#include <unordered_map>
using namespace std;

const uint64_t Radix = 1000000007;
const int MapReserve=10000000/2;

int n, m, d, k;
vector<vector<pair<int, uint64_t>>> gr;

struct state
{
    short store;
    uint64_t len;
    inline state(int store, uint64_t len)
    {
        this->store = store;
        this->len = len;
    }
    inline state(){}

    inline bool operator < (const state &x)const
    {
        return tie(store, len) < tie(x.store, x.len);
    }

    inline bool operator == (const state &x)const
    {
        return store==x.store && len == x.len;
    }

    inline uint64_t get_hash()const
    {
        //return len*(n+1) + store;
        return len * (n+1) + store;
    }
};

struct state_h
{
    inline uint64_t operator () (const state &s)const
    {
        return s.get_hash()%MapReserve;
    }
};

inline bool by_second_ascending(pair<int, int> x, pair<int, int> y)
{
    return x.second < y.second;
}

void solve()
{
    unordered_map<state, uint64_t, state_h> lastState;
    unordered_map<state, uint64_t, state_h> newState;

    lastState.reserve(MapReserve);
    newState.reserve(MapReserve);

    for(int i=1;i<=n;i++)lastState[{i, 0LL}]=1;
    for(int i=1;i<=n;i++)sort(gr[i].begin(), gr[i].end(), by_second_ascending);

    uint64_t answer=0;

    for(int it;;it++)
    {
        bool any=false;
        for(const auto &prev : lastState)
        {
            state prevState = prev.first;
            uint64_t prevCount = prev.second;

            for(pair<int, uint64_t> edge : gr[prevState.store])
            {
                int nextStore = edge.first;
                uint64_t newLen = (prevState.len + edge.second);
                if(newLen > k)break;
                newState[{nextStore, newLen}]+=prevCount;
                if(newLen%d==0)
                {
                    answer+=prevCount;
                }
                //printf("%lld %lld\n", newLen, newLen%d);
                any=true;
            }

            //globalState[prevState]+=prevCount;
            //globalState[prevState]%=Radix;
        }

        if(!any)break;

        lastState.clear();
        for(auto &x : newState)lastState.insert(x);
        newState.clear();
    }

    printf("%llu\n", answer%Radix);
}

void read()
{
    cin>>n>>m>>d>>k;
    gr.resize(n+1);
    for(int i=0;i<m;i++)
    {
        int x, y, len;
        cin>>x>>y>>len;
        gr[x].emplace_back(y, len);
        gr[y].emplace_back(x, len);
    }
}

int main()
{
    //cout<<INT_MAX<<endl;
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
}

/**
3 3 2 2
1 2 1
2 3 2
3 1 1


5 7 5 10
1 3 8
2 5 7
3 4 3
1 4 2
2 3 1
1 5 4
4 5 4

5 9 2 20
1 2 1
2 3 2
3 1 1
3 4 1
4 5 2
5 3 1
1 5 1
2 4 1
2 5 1

5 7 5000000 5000000
1 3 8
2 5 7
3 4 3
1 4 2
2 3 1
1 5 4
4 5 4
**/
