/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  khans
* score: 10.0
* date:  2017-11-24 11:53:01.735816
*/
#include <vector>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <unordered_map>
#include <tuple>
using namespace std;

int n, m, k;
vector<vector<int>> a;
vector<vector<int>> restoreTime;

const int MapSize = 1000000;

struct eaten
{
    int x, y, healTime;
    eaten(int x, int y, int healTime)
    {
        this->x=x;
        this->y=y;
        this->healTime=healTime;
    }

    bool operator < (const eaten &e)const
    {
        return tie(x, y, healTime)<tie(e.x, e.y, e.healTime);
    }

    bool operator == (const eaten &e)const
    {
        x==e.x && y==e.y && healTime == e.healTime;
    }
};

struct progress
{
    int x, y;
    set<eaten> recentlyEaten;

    progress(int x, int y, set<eaten> recentlyEaten)
    {
        this->x=x;
        this->y=y;
        this->recentlyEaten=std::move(recentlyEaten);
    }

    progress(){}

    bool operator < (const progress &p)const
    {
        return tie(x, y, recentlyEaten)<tie(p.x, p.y, p.recentlyEaten);
    }

    bool go_to(int x, int y, progress &result)const
    {
        if(x<1 || y<1 || x>n || y>m)return false;
        if(x==this->x && y==this->y)return false;

        set<eaten> newEaten;
        for(auto e : recentlyEaten)
        {
            if(e.healTime!=1)
            {
                if(e.x == x && e.y==y)return false;
                newEaten.emplace(e.x, e.y, e.healTime-1);
            }
        }
        newEaten.emplace(this->x, this->y, restoreTime[this->x][this->y]);

        result={x, y, newEaten};
        return true;
    }

    bool operator == (const progress &p)const
    {
        return x== p.x && y==p.y&& recentlyEaten == p.recentlyEaten;
    }

    bool left(progress &result)const
    {
        return go_to(x, y-1, result);
    }

    bool up(progress &result)const
    {
        return go_to(x-1, y, result);
    }

    bool right(progress &result)const
    {
        return go_to(x, y+1, result);
    }

    bool down(progress &result)const
    {
        return go_to(x+1, y, result);
    }

    void print()const
    {
        printf("tribe is at (%d, %d) and has eaten: \n", x, y);
        for(const auto &e : recentlyEaten)
        {
            printf("  (%d %d) with time to heal: %d\n", e.x, e.y, e.healTime);
        }
        putchar('\n');
    }
};

struct progress_h
{
    int operator () (const progress &p)const
    {
        int result = p.x*m + p.y;
        return result;
    }
};



void solve()
{
    uint64_t answer=a[1][1];
    map<progress, uint64_t> prev, next;
    prev[{1, 1, {}}]=a[1][1];

    for(int year=1;year<k;year++)
    {
        //puts("||||||||||||||||||||||||||||||||||||||||||||||||||");
        for(const auto &x : prev)
        {
            const progress &prevProg = x.first;
            //prevProg.print();
            uint64_t prevEaten = x.second;
            int prevX=prevProg.x;
            int prevY=prevProg.y;

            uint64_t nextEaten;
            progress nextProg;

            if(prevProg.up(nextProg))
            {
                nextEaten = prevEaten + a[prevX-1][prevY];
                next[nextProg]=max(next[nextProg], nextEaten);
                answer=max(answer, nextEaten);
            }

            if(prevProg.down(nextProg))
            {
                nextEaten = prevEaten + a[prevX+1][prevY];
                next[nextProg]=max(next[nextProg], nextEaten);
                answer=max(answer, nextEaten);
            }

            if(prevProg.left(nextProg))
            {
                nextEaten = prevEaten + a[prevX][prevY-1];
                next[nextProg]=max(next[nextProg], nextEaten);
                answer=max(answer, nextEaten);
            }

            if(prevProg.right(nextProg))
            {
                nextEaten = prevEaten + a[prevX][prevY+1];
                next[nextProg]=max(next[nextProg], nextEaten);
                answer=max(answer, nextEaten);
            }
        }
        prev=next;
        next.clear();
    }

    printf("%llu\n", answer);
}

void read()
{
    cin>>n>>m>>k;
    a.resize(n+1, vector<int>(m+1, 0));
    restoreTime.resize(n+1, vector<int>(m+1, 0));

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin>>a[i][j];

            restoreTime[i][j]=0;
            for(int r=1;;r*=2)
            {
                restoreTime[i][j]++;
                if(r>=a[i][j])break;
            }
        }
    }

    #ifndef EVAL
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            printf("%d ", restoreTime[i][j]);
        }
        putchar('\n');
    }
    #endif // EVAL
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();

    #ifndef EVAL
    system("pause");
    #endif // EVAL
}
/**
4 4 11
11 17 13 96
10 12 18 15
13 12 16 17
24 10 14 22


7 10 27
92 33 98 66 51 65 50 28 17 65
81 26 35 90 51 79 16 49 26 68
94 16 61 45 20 31 99 75 51 73
17 83 11 75 95 56 15 24 63 44
83 32 80 49 60 83 85 98 17 76
16 75 81 97 89 50 80 34 79 64
26 64 59 37 14 30 20 58 46 66

**/
