/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  superstition
* score: 5.0
* date:  2017-11-24 11:12:42.966048
*/
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <tuple>
#include <map>
#include <unordered_map>
using namespace std;

const uint64_t Radix = 1000000007;
const int MapReserve=100000;

int n, m, d, k;
vector<vector<pair<int, uint64_t>>> gr;

struct state
{
    short store;
    uint64_t len;
    state(int store, uint64_t len)
    {
        this->store = store;
        this->len = len;
    }
    state():state(0, 0){}

    bool operator < (const state &x)const
    {
        return tie(store, len) < tie(x.store, x.len);
    }

    bool operator == (const state &x)const
    {
        return store==x.store && len == x.len;
    }

    uint64_t get_hash()const
    {
        //return len*(n+1) + store;
        return store^len;
    }
};

struct state_h
{
    uint64_t operator () (const state &s)const
    {
        return s.get_hash()%MapReserve;
    }
};

bool by_second_ascending(pair<int, int> x, pair<int, int> y)
{
    return x.second < y.second;
}

int answer=0;

void go(int current, int sum)
{
    if(sum > k)return;
    if(sum%d==0)answer++;

    for(auto edge : gr[current])
    {
        go(edge.first, sum + edge.second);
    }
}

void solve()
{
    for(int i=1;i<=n;i++)go(i, 0);
    printf("%d\n", answer - n);
}

void read()
{
    cin>>n>>m>>d>>k;
    gr.resize(n+1);
    for(int i=0;i<m;i++)
    {
        int x, y, len;
        cin>>x>>y>>len;
        gr[x].emplace_back(y, len);
        gr[y].emplace_back(x, len);
    }
}

int main()
{
    //cout<<INT_MAX<<endl;
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();;
}

/**
3 3 2 2
1 2 1
2 3 2
3 1 1


5 7 5 10
1 3 8
2 5 7
3 4 3
1 4 2
2 3 1
1 5 4
4 5 4

5 9 2 20
1 2 1
2 3 2
3 1 1
3 4 1
4 5 2
5 3 1
1 5 1
2 4 1
2 5 1

5 7 5000000 5000000
1 3 8
2 5 7
3 4 3
1 4 2
2 3 1
1 5 4
4 5 4
**/
