/**
* user:  A1006
* fname: Ilia
* lname: Bozhinov
* task:  superstition
* score: 0.0
* date:  2017-11-24 10:07:44.372840
*/
#include <iostream>
#include <array>

using ll = long long;

const int sz = 250;
using vec = std::array<int, sz>;
using mat = std::array<vec, sz>;

int m;

const ll mod = 1000000007;

inline mat mul(const mat& a, const mat& b)
{
    mat r;

    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < m; j++)
        {
            for (int k = 0; k < m; k++)
            {
                r[i][j] = (r[i][j] + 1ll * a[i][k] * b[k][j]) % mod;
            }
        }
    }
    return r;
}

mat fpow(const mat& b, int exp)
{
    if (exp == 1) return b;

    mat h = fpow(b, exp / 2);
    h = mul(h, h);

    if (exp & 1)
        return mul(h, b);
    else
        return h;
}

void prmat(const mat& x)
{
    std::cout << std::endl;
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < m; j++) std::cout << x[i][j] << " ";
        std::cout << std::endl;
    }

}

int tmp[500];

int main()
{

    int n, e, k;
    std::cin >> n >> e >> k;

    int last = n + 1;

    mat b;


    for (int i = 0; i < e; i++)
    {
        int x, y, w;
        std::cin >> x >> y >> w;


        --w;

        tmp[0] = x;
        for (int i = 0; i< w; i++) tmp[i + 1] = last++;
        tmp[w + 1] = y;

        int sz = w + 2;

        for (int i = 0; i < sz - 1; i++)
            b[tmp[i]][tmp[i + 1]] =
                b[tmp[i + 1]][tmp[i]] = 1;
    }

    m = last;
    mat r = fpow(b, k);
    ll sum = 0;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n;j++)
        {
            sum += r[i][j];
            sum %= mod;
        }
    }

    std::cout << sum << std::endl;
}
