/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  khans
* score: 50.0
* date:  2017-11-24 11:45:54.906239
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 11;
const int MAX_M = 11;
const int MAX_K = 101;
const int X_MOVES[] = { -1, 0, 1, 0 };
const int Y_MOVES[] = { 0, 1, 0, -1 };
 
int CalcNeededYears(int x);
int ComputeDp(int x, int y, int rem, int encodedValue);
bool IsBitOne(int mask, int bit);
int SetBitToZero(int mask, int bit);

int n, m, k, a[MAX_N][MAX_M], usefulAgain[MAX_N][MAX_M], neededYears[MAX_N][MAX_M];
unordered_map< int, int > dp[MAX_N][MAX_M][MAX_K];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> n >> m >> k;

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			cin >> a[i][j];
			usefulAgain[i][j] = k;
			neededYears[i][j] = CalcNeededYears(a[i][j]);
		}
	}

	cout << ComputeDp(0, 0, k - 1, 0) + a[0][0] << endl;
	return 0;
}

int CalcNeededYears(int x) {
	int ans = 0, curr = 1;

	while(x > curr) {
		curr <<= 1;
		ans++;
	}

	return ans;
}

bool IsBitOne(int mask, int bit) {
	return ((mask & (1 << bit)) != 0);
}

int SetBitToZero(int mask, int bit) {
	return (mask ^ (1 << bit));
}

int ComputeDp(int x, int y, int rem, int encodedValue) {
	if(rem == 0) {
		return 0;
	}
	else if(dp[x][y][rem].count(encodedValue) != 0) {
		return dp[x][y][rem][encodedValue];
	}
	
	int currAns = 0;

	for(int d = 0; d < 4; d++) {
		int newX = x + X_MOVES[d];
		int newY = y + Y_MOVES[d];
	
		if(newX < 0 || newX >= n || newY < 0 || newY >= m) {
			continue;
		}

		if(usefulAgain[newX][newY] >= rem) {
			int newEncodedValue = encodedValue;
			if(IsBitOne(newEncodedValue, 12)) {
				newEncodedValue = SetBitToZero(newEncodedValue, 12);
			}
			if(IsBitOne(newEncodedValue, 13)) {
				newEncodedValue = SetBitToZero(newEncodedValue, 13);
			}
			
			newEncodedValue *= 4;
			newEncodedValue += d;
			
			int old = usefulAgain[x][y];
			usefulAgain[x][y] = rem - 1 - neededYears[x][y]; 
			currAns = max(currAns, ComputeDp(newX, newY, rem - 1, newEncodedValue) + a[newX][newY]);
			usefulAgain[x][y] = old;
		}
	}

	dp[x][y][rem][encodedValue] = currAns;
	return currAns;
}
