/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  superstition
* score: 35.0
* date:  2017-11-24 07:40:24.370890
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 85;
const int MAX_K = 1e4 + 5;
const int MOD = 1e9 + 7;

struct Node {
	int id;
	vector< pair< Node*, int > > v;

	Node(int id = 0) : id(id) {
		v.clear();
	}
};

int n, m, d, k, dp[MAX_N][MAX_K];
Node graph[MAX_N];

int ComputeDp(Node *node, int dist);

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> n >> m >> d >> k;
	
	for(int i = 1; i <= n; i++) {
		graph[i] = Node(i);
	}

	for(int i = 0; i < m; i++) {
		int x, y, t;
		cin >> x >> y >> t;

		graph[x].v.push_back({ &graph[y], t });
		graph[y].v.push_back({ &graph[x], t });
	}

	memset(dp, -1, sizeof(dp));
	
	int ans = 0;
	for(int i = 1; i <= n; i++) {
		ans = (1ll * ans + ComputeDp(&graph[i], 0)) % MOD;
	}

	cout << ans << endl;
	return 0;
}

int ComputeDp(Node *node, int dist) {
	if(dist > k) {
		return 0;
	}
	else if(dp[node->id][dist] != -1) {
		return dp[node->id][dist];
	}

	int currAns = 0;
	if(dist % d == 0 && dist != 0) {
		currAns++;
	}

	for(auto nxt : node->v) {
		Node *nxtNode = nxt.first;
		int nxtT = nxt.second;

		currAns = (1ll * currAns + 1ll * ComputeDp(nxtNode, dist + nxtT)) % MOD;
	}
	
	dp[node->id][dist] = currAns;
	return currAns;
}
