/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  khans
* score: 20.0
* date:  2017-11-24 10:43:10.764716
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 11;
const int MAX_M = 11;
const int MAX_K = 101;
const int X_MOVES[] = { -1, 0, 1, 0 };
const int Y_MOVES[] = { 0, 1, 0, -1 };
 
bool Check(int x, int y, int newX, int newY, const vector< char > &pastMoves);
int CalcNeededYears(int x);
int ComputeDp(int x, int y, int rem, vector< char > &pastMoves, int encodedValue);

int n, m, k, a[MAX_N][MAX_M], usefulAgain[MAX_N][MAX_M], neededYears[MAX_N][MAX_M];
unordered_map< int, int > dp[MAX_N][MAX_M][MAX_K];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> n >> m >> k;

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			cin >> a[i][j];
			usefulAgain[i][j] = k;
			neededYears[i][j] = CalcNeededYears(a[i][j]);
		}
	}

	vector< char > pastMoves;
	cout << ComputeDp(0, 0, k - 1, pastMoves, 0) + a[0][0] << endl;
	return 0;
}

bool Check(int x, int y, int newX, int newY, const vector< char > &pastMoves) {
	for(int i = pastMoves.size() - 1; i >= max(0, (int) pastMoves.size() - 7); i--) {
		if(pastMoves[i] == 0) {
			x++;
		}
		else if(pastMoves[i] == 1) {
			y--;
		}
		else if(pastMoves[i] == 2) {
			x--;
		}
		else {
			y++;
		}

		if(x == newX && y == newY) {
			int yearsPast = pastMoves.size() - i - 1;

			if(a[x][y] <= (1 << yearsPast)) {
				return true;
			}
			else {
				return false;
			}
		}
	}

	return true;
}

int CalcNeededYears(int x) {
	int ans = 0, curr = 1;

	while(x > curr) {
		curr <<= 1;
		ans++;
	}

	return ans;
}

int ComputeDp(int x, int y, int rem, vector< char > &pastMoves, int encodedValue) {
	if(rem == 0) {
		return 0;
	}
	else if(dp[x][y][rem].count(encodedValue) != 0) {
		return dp[x][y][rem][encodedValue];
	}
	
	int currAns = 0;

	for(int d = 0; d < 4; d++) {
		int newX = x + X_MOVES[d];
		int newY = y + Y_MOVES[d];
	
		if(newX < 0 || newX >= n || newY < 0 || newY >= m) {
			continue;
		}

		if(usefulAgain[newX][newY] >= rem) {
			vector< char > newPastMoves = pastMoves;
			newPastMoves.push_back(d);
			
			int newEncodedValue = encodedValue;
			if(newPastMoves.size() > 7) {
				newEncodedValue -= newPastMoves[0] * (1 << 12);
			}
			newEncodedValue *= 4;
			newEncodedValue += d;
	
			if(newPastMoves.size() > 7) {
				newPastMoves.erase(newPastMoves.begin());	
			}
			
			int old = usefulAgain[x][y];
			usefulAgain[x][y] = rem - neededYears[x][y]; 
			currAns = max(currAns, ComputeDp(newX, newY, rem - 1, newPastMoves, newEncodedValue) + a[newX][newY]);
			usefulAgain[x][y] = old;
		}
	}

	dp[x][y][rem][encodedValue] = currAns;
	return currAns;
}
